Index: config.php.sample
===================================================================
--- config.php.sample	(revision 1152)
+++ config.php.sample	(working copy)
@@ -32,7 +32,10 @@
 // Slashes at both ends.
 define("IA_URL_PREFIX", "--write-me-IA_URL_PREFIX--");
 
+// Define the place the avatars are being stored
+define("IA_AVATAR_FOLDER", "--write-me-IA_AVATAR_FOLDER--");
 
+
 // Congratulations! You're done with the essential configuration.
 // --------------------------------------------------------------
 // There are some more settings to adjust but they are optional.
Index: scripts/make-avatar-folder
===================================================================
--- scripts/make-avatar-folder	(revision 0)
+++ scripts/make-avatar-folder	(revision 0)
@@ -0,0 +1,116 @@
+#! /usr/bin/env php
+<?php
+
+// Putting a new constant in the config file
+// I think it's better this way because when I upload the diff the config file represents a new file
+
+$configfile = file(dirname($argv[0]) . "/../config.php");
+
+$newpath = realpath(dirname($argv[0]) . '/../') . '/' . "www/static/images/avatar/";
+
+$n = count($configfile);
+if ($n < 3 || array_search("define(\"IA_AVATAR_FOLDER\", \"" . $newpath."\");\n", $configfile) == false) {
+    $row = array_search("// Congratulations! You're done with the essential configuration.\n", $configfile);
+
+    $f = fopen(dirname($argv[0])."/../config.php", 'w');
+    for ($i = 0; $i < $row - 1; ++$i)
+        fwrite($f, $configfile[$i]);
+    
+    fwrite($f, "// Define the place the avatars are being stored\n");
+    fwrite($f, "define(\"IA_AVATAR_FOLDER\", \"" . $newpath . "\");\n");
+    fwrite($f, "\n");
+    
+    for ($i = $row - 1; $i < $n; ++$i)
+        fwrite($f, $configfile[$i]);
+    fclose($f);
+}
+
+require_once(dirname($argv[0])."/utilities.php");
+require_once(IA_ROOT_DIR.'common/db/db.php');
+require_once(IA_ROOT_DIR.'www/controllers/attachment.php');
+require_once(IA_ROOT_DIR.'www/controllers/image_attachment.php');
+require_once(IA_ROOT_DIR.'common/db/attachment.php');
+require_once(IA_ROOT_DIR.'common/cache.php');
+require_once(IA_ROOT_DIR.'common/db/user.php');
+require_once(IA_ROOT_DIR.'www/controllers/avatar.php');
+
+// Managing the .htaccess file for missing images
+
+$htaccess = file(IA_ROOT_DIR.'www/.htaccess');
+$n = count($htaccess);
+$row = array_search("RewriteCond %{REQUEST_URI}  !^.*/news_feed$\n", $htaccess);
+
+if ($htaccess[$row + 1] != "RewriteCond %{REQUEST_URI}  !^.*/avatar/.*$\n") {
+    $f = fopen(IA_ROOT_DIR.'www/.htaccess', 'w');
+
+    for ($i = 0; $i <= $row; ++$i)
+        fwrite($f, $htaccess[$i]);
+
+    fwrite($f, "RewriteCond %{REQUEST_URI}  !^.*/avatar/.*$\n");
+    for ($i = $row + 1; $htaccess[$i] != "RewriteRule ^(.*) index.php?page=$1 [QSA]\n"; ++$i)
+        fwrite($f, $htaccess[$i]);
+    fwrite($f, $htaccess[$i]);
+    
+    fwrite($f, "\nRewriteRule ^avatar/(tiny|small|normal|forum|big|full)/(.+)$ static/images/avatar/$1/a$2\n" .
+           "RewriteCond %{REQUEST_FILENAME} !-f\nRewriteCond %{REQUEST_FILENAME} !-d\n" . 
+           "RewriteRule ^static/images/avatar/(tiny|small|normal|forum|big|full)/(.+)$ static/images/avatar/$1/noimage\n\n");
+    
+    for (++$i; $i < $n; ++$i)
+        fwrite($f, $htaccess[$i]);
+    fclose($f);
+}
+
+// Database connect
+db_connect();
+
+// Managing the userinfo template from the textblock table
+$query = "UPDATE ia_textblock SET text = 'table(compact). |=/5. ==UserImage(user=\"%user%\" size=\"big\")==\r\n{\'Vezi solutiile trimise\':monitor?user=%user%}\r\n|_. Nume | == userinfo(user=\"%user%\" info=\"fullname\")== |\r\n| |_. Cont | ==userinfo(user=\"%user%\" info=\"username\")== |\r\n| |_. Rating | ==userinfo(user=\"%user%\" info=\"rating\")== |\r\n| |_. Statut | ==userinfo(user=\"%user%\" info=\"security\")== |\r\n|_. Forum | ==SmfLink(user=\"%user%\" link=\"pm\" caption=\"trimite mesaj privat\")==, ==SmfLink(user=\"%user%\" link=\"stats\" caption=\"vezi activitate\")== |\r\n\r\n\r\n' WHERE name = 'template/userinfo';";
+db_query($query);
+
+// getting the user list
+$query = "SELECT username FROM ia_user";
+$res = db_query($query);
+$rows = mysql_num_rows($res);
+
+// taking care of the noimage file
+$noimage_filepath = attachment_get_filepath(attachment_get('noimage', 'template/infoarena'));
+$resize_sizes = 5;
+
+// creating the avatar folder if it does not exists, and grant it permissions
+if (file_exists(IA_AVATAR_FOLDER) == false) {
+    mkdir(IA_AVATAR_FOLDER, 0777);
+    $size_types = array("tiny", "small", "normal", "forum", "big", "full");
+    foreach ($size_types as $size) {
+        mkdir(IA_AVATAR_FOLDER."/".$size, 0777);
+    }
+}
+
+// resizing the noimage file
+$ret = getimagesize($noimage_filepath);
+avatar_resize($noimage_filepath, $ret, 'noimage');
+
+// Going through all the users
+for ($i = 0; $i < $rows; ++$i) {
+    $user = mysql_result($res, $i);
+    $attach = attachment_get('avatar', 'utilizator/'.$user);
+    $found = !is_null($attach);
+
+    if ($found) {
+        $real_name = attachment_get_filepath($attach);
+        $found = file_exists($real_name);
+    }
+
+    if (!$found) {
+        continue;
+    }
+
+    $ret = getimagesize($real_name);
+    if ($ret == false) {
+        continue;
+    }
+
+    // The user has a valid image, resizing it, but keeping the attachment
+	avatar_resize($real_name, $ret, "a".$user);
+}
+
+?>

Index: scripts/setup
===================================================================
--- scripts/setup	(revision 1152)
+++ scripts/setup	(working copy)
@@ -137,6 +137,10 @@
 $config_vars['IA_ROOT_DIR'] = read_line("SVN checkout dir?", $config_vars['IA_ROOT_DIR']);
 $config_vars['IA_ROOT_DIR'] = slash_string(
         realpath($config_vars['IA_ROOT_DIR']), true, true);
+$config_vars['IA_AVATAR_FOLDER'] = $config_vars['IA_ROOT_DIR'].'www/static/images/avatar/';
+$config_vars['IA_AVATAR_FOLDER'] = read_line("Avatar Folder?", $config_vars['IA_AVATAR_FOLDER']);
+$config_vars['IA_AVATAR_FOLDER'] = slash_string(
+        realpath($config_vars['IA_AVATAR_FOLDER']), true, true);
 $config_vars['IA_URL_HOST'] = read_line("Host part of url (with http)?",
         $config_vars['IA_URL_HOST']);
 $config_vars['IA_URL_HOST'] = slash_string(
@@ -222,6 +226,7 @@
     $sitename = read_line("Site name?", $sitename);
     system("chmod g+ws {$ia_root}attach");
     system("chmod g+ws {$ia_root}cache");
+    system("chmod g+ws {$ia_root}www/static/images/avatar");
     system("chmod g+ws {$ia_root}www/static/images/tmp");
     system("chmod g+ws {$ia_root}www/static/images/latex");
 
Index: smf/Sources/Load.php
===================================================================
--- smf/Sources/Load.php	(revision 1152)
+++ smf/Sources/Load.php	(working copy)
@@ -1004,7 +1004,7 @@
 	}
 
 	// use infoarena avatars
-	$avatar_img_src = url_user_avatar($profile['memberName'], '75x75', true);
+	$avatar_img_src = url_user_avatar($profile['memberName'], 'forum', true);
 
 	// What a monstrous array...
 	$memberContext[$user] = array(
Index: www/controllers/account.php
===================================================================
--- www/controllers/account.php	(revision 1152)
+++ www/controllers/account.php	(working copy)
@@ -3,6 +3,7 @@
 require_once(IA_ROOT_DIR."common/db/user.php");
 require_once(IA_ROOT_DIR."common/db/attachment.php");
 require_once(IA_ROOT_DIR."common/db/smf.php");
+require_once(IA_ROOT_DIR."www/controllers/avatar.php");
 require_once(IA_ROOT_DIR."www/controllers/account_validator.php");
 
 // identify target user and check permission to edit profile
@@ -131,6 +132,16 @@
                         $errors['avatar'] = 'Fisierul nu a putut fi incarcat '
                                             .'pe server.';
                     }
+                    else {
+                        // resize the avatar if it is a correct mime-type
+                        $IA_SAFE_MIME_TYPES = array('image/jpeg', 'image/pjpeg', 'image/png' , 'image/gif', 'image/bmp', 'image/x-ms-bmp');
+                        $ret = getimagesize($disk_name);
+                        // check if mime-type is from accepted ones
+                        if (in_array($ret['mime'], $IA_SAFE_MIME_TYPES)) {
+                            avatar_resize($disk_name, $ret, "a".$user['username']);
+                        }
+                    }
+
                 }
             }
 
Index: www/controllers/avatar.php
===================================================================
--- www/controllers/avatar.php	(revision 0)
+++ www/controllers/avatar.php	(revision 0)
@@ -0,0 +1,66 @@
+<?php
+
+require_once(IA_ROOT_DIR.'common/db/db.php');
+require_once(IA_ROOT_DIR.'www/controllers/attachment.php');
+require_once(IA_ROOT_DIR.'www/controllers/image_attachment.php');
+require_once(IA_ROOT_DIR.'common/db/attachment.php');
+require_once(IA_ROOT_DIR.'www/controllers/account_validator.php');
+require_once(IA_ROOT_DIR.'common/common.php');
+
+function avatar_resize($real_name, $ret, $user) {
+    $resize_size = array('L16x16', 'L32x32', 'L50x50', '75x75', '150x150');
+    $resize_sizes = 5;
+    
+    $size_types = array('tiny/', 'small/', 'normal/', 'forum/', 'big/', 'full/');
+
+    copy($real_name, IA_AVATAR_FOLDER.$size_types[$resize_sizes].$user);
+
+    list($img_width, $img_height, $img_type, $img_attr) = $ret;
+    for ($j = 0; $j < $resize_sizes; ++$j) {
+        list($new_width, $new_height) = resize_coordinates($img_width, $img_height, $resize_size[$j]);
+
+        // resizing
+		switch ($img_type) {
+            case IMAGETYPE_GIF:
+                // NOTE: animated GIFs become static. Only the first frame is saved
+                // Seems like a good thing anyway
+                $im = imagecreatefromgif($real_name);
+                $im_resized = imagecreate($new_width, $new_height);
+                // reset palette and transparent color to that of the original file
+                $trans_col = imagecolortransparent($im);
+                imagepalettecopy($im_resized, $im);
+                imagefill($im_resized, 0, 0, $trans_col);
+                imagecolortransparent($im_resized, $trans_col);
+                imagecopyresampled($im_resized, $im, 0, 0, 0, 0, $new_width, $new_height, $img_width, $img_height);
+                imagegif($im_resized, IA_AVATAR_FOLDER.$size_types[$j].$user);
+                break;
+
+            case IMAGETYPE_JPEG:
+                $im = imagecreatefromjpeg($real_name);
+                $im_resized = imagecreatetruecolor($new_width, $new_height);
+                imagecopyresampled($im_resized, $im, 0, 0, 0, 0, $new_width, $new_height, $img_width, $img_height);
+                imagejpeg($im_resized, IA_AVATAR_FOLDER.$size_types[$j].$user);
+                break;
+
+            case IMAGETYPE_PNG:
+                $im = imagecreatefrompng($real_name);
+                $im_resized = imagecreatetruecolor($new_width, $new_height);
+                // turn off the alpha blending to keep the alpha channel
+                imagealphablending($im_resized, false);
+                // allocate transparent color
+                $col = imagecolorallocatealpha($im_resized, 0, 0, 0, 127);
+                // fill the image with the new color
+                imagefilledrectangle($im_resized, 0, 0, $new_width, $new_height, $col);
+                imagecopyresampled($im_resized, $im, 0, 0, 0, 0, $new_width, $new_height, $img_width, $img_height);
+                imagesavealpha($im_resized, true);
+                imagepng($im_resized, IA_AVATAR_FOLDER.$size_types[$j].$user);
+                break;
+
+            default:
+                // unsupported image type
+                // but we already know the image passed is if one of the types above
+        }
+    }
+}
+
+?>
Index: www/format/format.php
===================================================================
--- www/format/format.php	(revision 1152)
+++ www/format/format.php	(working copy)
@@ -129,12 +129,10 @@
 }
 
 // Format avatar img.
-function format_user_avatar($user_name, $width = 50, $height = 50,
+function format_user_avatar($user_name, $size_type = "full",
                             $absolute = false)
 {
-    log_assert(is_whole_number($width), "Invalid width");
-    log_assert(is_whole_number($height), "Invalid height");
-    $url = url_user_avatar($user_name, "L{$width}x{$height}");
+    $url = url_user_avatar($user_name, $size_type);
     if ($absolute) {
         $url = url_absolute($url);
     }
@@ -165,7 +163,7 @@
     $result = "";
     $result .= "<span class=\"tiny-user\">";
     $result .= format_link($user_url,
-                           format_user_avatar($user_name, 16, 16, false).$user_fullname,
+                           format_user_avatar($user_name, "tiny", false).$user_fullname,
                            false);
     $result .= ' '.$rbadge;
     $result .= "<span class=\"username\">"
@@ -187,7 +185,7 @@
     $result = "";
     $result .= "<div class=\"normal-user\">";
     $result .= format_link($user_url,
-                           format_user_avatar($user_name, 32, 32, false),
+                           format_user_avatar($user_name, "small", false),
                            false);
     $result .= "<span class=\"fullname\">$user_fullname</span><br />";
     $result .= $rbadge;
Index: www/htaccess.sample
===================================================================
--- www/htaccess.sample	(revision 1152)
+++ www/htaccess.sample	(working copy)
@@ -11,7 +11,14 @@
 RewriteCond %{REQUEST_URI}  !^.*/favicon\.ico$
 RewriteCond %{REQUEST_URI}  !^.*/stiri/.*$
 RewriteCond %{REQUEST_URI}  !^.*/news_feed$
+RewriteCond %{REQUEST_URI}  !^.*/avatar/.*$
 RewriteRule ^(.*) index.php?page=$1 [QSA]
+
+RewriteRule ^avatar/(tiny|small|normal|forum|big|full)/(.+)$ static/images/avatar/$1/a$2
+RewriteCond %{REQUEST_FILENAME} !-f
+RewriteCond %{REQUEST_FILENAME} !-d
+RewriteRule ^static/images/avatar/(tiny|small|normal|forum|big|full)/(.+)$ static/images/avatar/$1/noimage
+
 RewriteRule ^stiri/(.*)$ blog/$1 [R=301,QSA]
 RewriteRule ^news_feed$ blog?action=rss [R=301,QSA]
 
Index: www/macros/macro_userimage.php
===================================================================
--- www/macros/macro_userimage.php	(revision 0)
+++ www/macros/macro_userimage.php	(revision 0)
@@ -0,0 +1,15 @@
+<?php
+
+require_once(IA_ROOT_DIR.'www/format/format.php');
+
+function macro_userimage($args) {
+    $user = $args['user'];
+
+    $size_type = $args['size'];
+    $size_types = array("tiny", "small", "normal", "forum", "big", "full");
+
+    if (!in_array($size_type, $size_types))
+        return macro_error("Unkown size type \"".$size_type."\".");
+
+    return format_link(url_complex("avatar/full/".$user), format_user_avatar($user, $size_type, false), false);
+}
Index: www/static/images/avatar/.htaccess
===================================================================
--- www/static/images/avatar/.htaccess	(revision 0)
+++ www/static/images/avatar/.htaccess	(revision 0)
@@ -0,0 +1,6 @@
+#RewriteEngine On
+
+#RewriteCond %{REQUEST_FILENAME} !-f
+#RewriteCond %{REQUEST_FILENAME} !-d
+#RewriteRule ^normal/(.+)$ normal/noimage.img
+
Index: www/url.php
===================================================================
--- www/url.php	(revision 1152)
+++ www/url.php	(working copy)
@@ -238,8 +238,8 @@
     ));
 }
 
-function url_user_avatar($username, $resize = "50x50") {
-    return url_image_resize(IA_USER_TEXTBLOCK_PREFIX . $username, 'avatar', $resize);
+function url_user_avatar($username, $size_type = "full") {
+    return url_complex("avatar/".$size_type."/".$username);
 }
 
 function url_unsubscribe($username, $key) {
Index: www/views/account.php
===================================================================
--- www/views/account.php	(revision 1152)
+++ www/views/account.php	(working copy)
@@ -91,7 +91,7 @@
         <li>
             <?php
                 // display avatar
-                $avatar_url = url_user_avatar($user['username'], "150x150");
+                $avatar_url = url_user_avatar($user['username'], "big");
                 echo '<img class="avatar" src="'.html_escape($avatar_url).'" alt="avatar"/>';
             ?>
         </li>
Index: www/views/sitewide.php
===================================================================
--- www/views/sitewide.php	(revision 1152)
+++ www/views/sitewide.php	(working copy)
@@ -15,7 +15,7 @@
 <div id="header" class="clear">
     <?php if (!identity_is_anonymous()) { $username = $identity_user['username']; ?>
         <div id="userbox">
-        <?= format_link(url_user_profile($username, true), format_user_avatar($username, 50, 50, true), false) ?>
+        <?= format_link(url_user_profile($username, true), format_user_avatar($username, "normal", true), false) ?>
             <div class="user">
                 <strong><?= html_escape($identity_user['full_name']) ?></strong><br/>
                 <?= format_user_ratingbadge($username, $identity_user['rating_cache']) ?>
